%% Clase tesisFIE.cls 
%% 28/Feb/2005 Ver. 0.0.1

% EXTENSIN DE HUTHESIS CLASS for LaTeX version 2e - 11/3/94
% CUYA INFORMACIN ES LA SIGUIENTE
%%% ====================================================================
%%%  @LaTeX-class-file{
%%%     filename        = "huthesis.cls",
%%%     version         = "1.3",
%%%     date            = "6 Jan 2004",
%%%     portedby        = "Alex Barnett",
%%%     address         = "Courant Institute (ex Harvard Physics)"
%%%     telephone       = "(212)-998-3296",
%%%     email           = "barnett AT cims DOT nyu DOT edu",
%%%     codetable       = "ISO/ASCII",
%%%     keywords        = "LaTeX, huthesis",
%%%     supported       = "not really supported; I react to user input",
%%%     docstring       = " Original Description:
%%%                        This file is the main file for the huthesis
%%%                        class, which is intended to meet the requirements
%%%                        for University of California Ph.D. dissertations.
%%%                        It is a direct port from UCTHESIS
%%%                        v2.7 by Ethan V. Munson, with no changes other 
%%%                        than those for compatibility.  The major modifictions
%%%                        are in the font selection commands in the option
%%%                        files uct1x.clo.
%%%                        
%%%                        UCTHESIS.STY v2.7 is based on the standard
%%%                        report.sty as modified by Mittelbach and Schopf in
%%%                        Jan 1992.  The primary differences are (1) the use
%%%                        of pseudo-double-spacing, except in certain special
%%%                        environments; and (2) the use of a 6 inch line
%%%                        with 4em paragraph indentation.  It is only
%%%                        intended for single-sided printing.  Double-sided
%%%                        printing may be possible, but you're on
%%%                        your own.
%%%
%%%                        I know of no bugs in this implementation,
%%%                        but would be happy to hear of any problems
%%%                        that arise with it.
%%%
%%%                        Version 2.x fixes a bug in the previous
%%%                        version of 20 Jun 1988.  The bug was that 
%%%                        "draft" optional mode didn't work because of
%%%                        problems in handling optional arguments.
%%%                        This file does not seem to work with earlier 
%%%                        versions of LaTeX (pre-Jan 1992).
%%%
%%%                        Version 2.3 includes a single-spaced 
%%%                        tabular* environment.
%%%                     
%%%                        Version 2.4 sets \evensidemargin correctly
%%%                        for two-sided style.  It also adds new
%%%                        environments (\smalltabular and
%%%                        \scriptsizetabular) which produce tables
%%%                        with smaller fonts.  The obvious methods
%%%                        of producing small-font tables don't work
%%%                        in ucthesis style.
%%%
%%%                        Version 2.5 adds support for the \maketitle
%%%                        macro.
%%%
%%%                        Version 2.6 adds support for complete and
%%%                        correct front matter.  Some dead code was
%%%                        removed, too.
%%%
%%%                        Version 2.7 adds front matter support for
%%%                        thesis committees of more than 3 people
%%%                        and for a labeled signature line on the
%%%                        abstract page.
%%%
%%%                        Version 3.0 is a direct port of version 2.7
%%%                        to LaTeX2e.  The major revisions in ucthesis.cls
%%%                        are converting option processing to LaTeX2e 
%%%                        conventions.  The uct1x files have been revised
%%%                        to use the new font selection commands.
%%%
%%%                        Some users have had problems with the 
%%%                        margins ending up too small on one side.
%%%                        This appears to be a DVI-to-PostScript
%%%                        driver or printer-adjustment problem.
%%%                        If you have such trouble, make small adjustments
%%%                        to the \textwidth and \oddsidemargin
%%%                        settings in your document preamble.
%%%                        
%%%                        Another problem some people have had is
%%%                        that you can't use \pagestyle{headings}
%%%                        and \markboth if you use \part.  The solution
%%%                        is to get the headerfooter style, which is
%%%                        nice and simple to use.
%%%
%%%            Adam S. Lupu-Sax ported to Harvard:
%%%                        huthesis 1.0 is a direct port with a bit of extra
%%%                        work on the double sided printing.  The
%%%                        approval page has been removed and the
%%%                        cover page and other frontmatter fixed
%%%                        appropriately. Margins and headers are as
%%%                        specified by Harvard. [Adam Lupu-Sax, 1998]
%%%
%%%                        huthesis 1.1 changed by Alex Barnett to fit new
%%%                        Jan 2000 `Form of the Doctoral Thesis' from
%%%            GSAS at Harvard.
%%%            Additional thanks:
%%%            Bill Bies
%%%            Marc Hill
%%%            "
%%%            huthesis 1.3: [Alex Barnett, Jan 2004]
%%%                        Jan 2004, Bug found by Jamie Kellogg, fix
%%%                        by David Kastrup (author of preview-latex).
%%%
%%%
%%%
%%% ====================================================================
%%%         MODIFICACIN DE HUTHESIS.CLS PARA CREACIN DE TESISFIE.CLS
%%%     Clase para el formato de tesis de la Divisin de Estudios de Posgrado
%%%     de la Facultad de Ingeniera Elctrica de la Universidad Michoacana de
%%%     San Nicols de Hidalgo
%%% 
%%%     La Clase tesisFie.cls define los parmetros de formato requeridos para
%%%     la elaboracin de tesis escritas en Latex2e
%%%     
%%%     Febrero-2005
%%%     Sergio Bravo, Mario Graff, Eric Sadit and  Luis E. Gamboa
%%%
%%%
%%%     Los comentarios se hicieron en espaol para ampliar la posibilidad
%%%     de mejoras en prximas versiones.
%%%     Las caractersticas del documento generado con esta clase estn
%%%     apegadas a los requerimientos sugeridos para las tesis de Maestra
%%%     y Doctorado en la Divisin de Estudios de Posgrado de la Facultad de
%%%     Ingeniera Elctrica.
%%%            
%%%  }
%%% ====================================================================


%% REQUIERE:
%% Los archivos de definiciones tfie11.clo y tfie12.clo 

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{tesisFIE}[2004/02/28 v1.0 Divisin de Estudios de Posgrado en FIE, UMSNH.]
\RequirePackage{fancyhdr}
\RequirePackage{ifthen}


\usepackage[spanish]{babel}         % Utiliza los nombres de figuras, etc. En el idioma que se quiera
\spanishdecimal{.}
%%Para hacer algoritmos
\usepackage{floatFIE}

%%algem es un flotante para algoritmos 
\floatstyle{ruled}
\newfloat{algem}{htbp}{loa}
\floatname{algem}{Algoritmo}

%%Es una ambiente para hacer algoritmos.

\newenvironment{algoritmo}{
  \begin{algem}
    \begin{center}
      \begin{minipage}[t]{0.9\textwidth}
        ~\\}{
      \end{minipage}
    \end{center}
  \end{algem}}

%%Para usar esta macro es necesario tener el paquete nuevoalg
%%Facilita el uso del ambiente nuevoalg y algoritmo. 
%%Recibe 5 parmetros: 
%%1)Nombre del algoritmo
%%2)Argumentos del algoritmo
%%3)Caption
%%4)Label
%%5)El algoritmo

\newcommand{\algcormen}[5]{
  \begin{algoritmo}
    \begin{algorithm}{#1}{#2}
      #5
    \end{algorithm}
    \caption{#3}
    \label{#4}
  \end{algoritmo}
}


%%Crea el ndice de algoritmos

\def\listalgorithmsname{Lista de Algoritmos}




%\def\listalgorithmsname{Lista de Algoritmos}
%
%\newcommand{\listofalgorithms}{\@restonecolfalse
%  \if@twocolumn\@restonecoltrue\onecolumn\fi
%  \chapter*{\listalgorithmsname\@mkboth{\uppercase{\listalgorithmsname}}%
%{\uppercase{\listalgorithmsname}}}
%   \addcontentsline{toc}{section}{\listalgorithmsname}
%   {\ssp\@starttoc{loa}}\if@restonecol
%    \twocolumn\fi}

%%terminan algoritmos




% OPCIONES
% Se declaran las opciones de la clase, y se definen los valores por defecto
% 12 pts, twoside, final (no hay borradores)
\newcommand\@ptsize{}
\newcommand\@draftmark{}
\newif\if@elpt
\newif\if@twpt
\newif\if@dbl

\DeclareOption{11pt}{\renewcommand\@ptsize{1} \@elpttrue}
\DeclareOption{12pt}{\renewcommand\@ptsize{2} \@twpttrue}
\DeclareOption{oneside}{\@twosidefalse \@mparswitchfalse}
\DeclareOption{twoside}{\@twosidetrue  \@mparswitchtrue}
\DeclareOption{doublespace}{\@dbltrue}
\DeclareOption{draft}{\renewcommand\@draftmark{1}}
\DeclareOption{final}{\renewcommand\@draftmark{0}}
\DeclareOption{openbib}{%
  \AtEndOfPackage{%
   \renewcommand\@openbib@code{%
      \advance\leftmargin\bibindent
      \itemindent -\bibindent
      \listparindent \itemindent
      \parsep \z@
      }%
   \renewcommand\newblock{\par}}%
}
\ExecuteOptions{letterpaper,11pt,twoside,final}


% Se define la opcin de impresin en doble pgina
\def\ds@twoside{\@twosidetrue  %  Defines twoside option.
           \@mparswitchtrue}   %    Marginpars go on outside of page.


% Se procesan las opciones que se han escrito en \documentclass
% o los valores por defecto
\ProcessOptions

% ELEGIMOS EL TAMAO DE LETRA
% Se definen a continuacin los tipos de letra, los mrgenes
% los nombres de captulos, etc. Todo depende del tamao de letra
% seleccionado al inicio
% 11pt : hut11, 12pt : hut12
% NOTA: los archivos hut11.clo y hut12.clo son necesarios para el buen 
% funcionamiento de la clase
\input tfie1\@ptsize.clo\relax

% Para algunos ambientes es necesario cambiar el formato a espacio simple
% por esta razn se define la macro \ssp
\def\ssp{\def\baselinestretch{1.0}\large\normalsize}


% Se definen tambin el doble y espacio intermedio
\def\hsp{\def\baselinestretch{1.37}\large\normalsize} % intermediate spacing
\def\dsp{\def\baselinestretch{1.5}\large\normalsize} %

% \smallssp se utiliza para producir ambientes tabulares con fuentes pequeas.
% Esto se requiere porque en espacio simple se requiere un cambio en el tamao
% de la letra. \scriptsizesp es una versin ms pequea de los mismo
\def\smallssp{\def\baselinestretch{1.0}\large\small}
\def\scriptsizessp{\def\baselinestretch{1.0}\large\scriptsize}


% OTROS LENGUAJES
% Puesto que la tesis puede ser escrita en otro lenguaje, se provee de
% nombres de figuras, tablas, captulos, etc. variables.

\addto\captionsspanish{%
\def\contentsname{Contenido}
\def\listfigurename{Lista de Figuras}
\def\listtablename{Lista de Tablas}
\def\listsymbolname{Lista de S\'imbolos}
\def\bibname{Referencias}
\def\indexname{\'Indice}
\def\figurename{Figura}
\def\tablename{Tabla}
\def\chaptername{Cap\'itulo}
\def\appendixname{Ap\'endice}
\def\partname{Parte}
\def\abstractname{Resumen}
\def\acknowledgename{Agradecimientos}
\def\citationname{Lista de Publicaciones}
}


%\def\contentsname{Contenido}
%\def\listfigurename{Lista de Figuras}
%\def\listtablename{Lista de Tablas}
%\def\listsymbolname{Lista de S\'imbolos}
%\def\bibname{Referencias}
%\def\indexname{\'Indice}
%\def\figurename{Figura}
%\def\tablename{Tabla}
%\def\chaptername{Cap\'itulo}
%\def\appendixname{Ap\'endice}
%\def\partname{Parte}
%\def\abstractname{Resumen}
%\def\acknowledgename{Agradecimientos}
%\def\citationname{Lista de Publicaciones}


% PORTADA Y PGINAS DE INICIO
% La portada contiene los datos que se requieren en la pgina inicial
% de una tesis en el departamento de ingeniera elctrica de la UMICH

%ao de graduacin
\def\degreeyear#1{\gdef\@degreeyear{#1}}    
%mes
\def\degreemonth#1{\gdef\@degreemonth{#1}}  

%nombre del grado a obtener
\def\degree#1{\gdef\@degree{#1}}            

%nombde del asesor y coasesores
\def\advisor#1{\gdef\@advisor{#1}}          
\def\coadvisorone#1{\gdef\@coadvisorone{#1}}    
\def\coadvisortwo#1{\gdef\@coadvisortwo{#1}}
\def\coadvisorthree#1{\gdef\@coadvisorthree{#1}}

%departamento
\def\department#1{\gdef\@department{#1}}    

%especialidad (programacin, control, potencia)
\def\field#1{\gdef\@field{#1}}       

\def\maketitle{
{
    \pagenumbering{roman} % Jan 2000 GSAS Harvard req.
    \hsp % intermediate spacing for title page.
  \newpage
  \thispagestyle{empty}
%  \addcontentsline{toc}{section}{Title Page}
  \centerline{\ }
  \ifthenelse{\equal{\@coadvisorthree}{}}{\vspace{0.3in}}{}
  \ifthenelse{\equal{\@coadvisortwo}{}}{\vspace{0.3in}}{}
  \ifthenelse{\equal{\@coadvisorone}{}}{\vspace{0.3in}}{}
  \begin{center}
    {\Large\bf{\MakeUppercase{\@title}}}
  \end{center}
  \centerline{\ }
  \centerline{\ }
  \centerline{\bf{TESIS}}
  \centerline{\ }
  \centerline{\ }
  \centerline{Que para obtener el grado de}
  \centerline{\MakeUppercase{\bf{\@degree}}}
  \centerline{\ }
  \centerline{\ }
  \centerline{presenta}
  \centerline{\bf{\@author}}
  \centerline{\ }
  \centerline{\ }
  \centerline{\bf{\@advisor}}\centerline{\small{\bf{Director de Tesis}}}
  \centerline{\ }
  \centerline{\ }
  \ifthenelse{\equal{\@coadvisorone}{}}{}{\centerline{\bf{\@coadvisorone}}\centerline{\small{\bf{Co-Director de Tesis}}}\centerline{\ }}
  \ifthenelse{\equal{\@coadvisortwo}{}}{}{\centerline{\bf{\@coadvisortwo}}\centerline{\small{\bf{Co-Director de Tesis}}}\centerline{\ }}
  \ifthenelse{\equal{\@coadvisorthree}{}}{}{\centerline{\bf{\@coadvisorthree}}\centerline{\small{\bf{Co-Director de Tesis}}}\centerline{\ }}
  \centerline{\ }
  \centerline{Universidad Michoacana de San Nicol\'as de Hidalgo}
  \centerline{\ }
  \centerline{{\@degreemonth} {\@degreeyear}}
  \setcounter{footnote}{0}
  }
}
      


% ABSTRACT EN ESPAOL
% El formato requiere un resumen en espaol de la tesis
\newenvironment{abstractSP}
{
  \cleardoublepage
  \thispagestyle{empty}
    \@mkboth{\abstractname}{\abstractname}
  \addcontentsline{toc}{section}{Resumen}
  \centerline{\bf {\LARGE Resumen}}
  \centerline{\ }
} {}

% ABSTRACT EN INGLS
% El formato requiere un resumen en ingls
\newenvironment{abstractEN}
{
  \cleardoublepage
  \thispagestyle{empty}
    \@mkboth{\abstractname}{\abstractname}
  \addcontentsline{toc}{section}{Abstract}
  \centerline{\bf {\LARGE Abstract}}
  \centerline{\ }
} {}
 
 
% DEDICATORIA
% Este ambiente sirve para justificar a la izquierda el texto de la dedicatoria
\newenvironment{dedication}
{
  \cleardoublepage
  \thispagestyle{empty}
  \vspace*{1in}
  \addcontentsline{toc}{section}{Dedicatoria}
}
{}

% AGRADECIMIENTOS
% Ambiente para los agradecimientos que inicia una nueva pgina
% con el ttulo centrado "Agradecimientos" en negritas
\newenvironment{acknowledgments}
{
  \cleardoublepage
  \thispagestyle{empty}
    \@mkboth{\acknowledgename}{\acknowledgename}
  \addcontentsline{toc}{section}{Agradecimientos}
  {\centerline{\bf {\LARGE Agradecimientos}}}
  \vspace*{.2in}
}
{}


% LISTA DE SMBOLOS
\newenvironment{symbols}
{  \chapter*{\listsymbolname\@mkboth{\uppercase{\listsymbolname}}%
   {\uppercase{\listsymbolname}}}
   \addcontentsline{toc}{section}{\listsymbolname}
   \ssp
}
{\dsp}


% LISTA DE ALGORITMOS

\newcommand{\listofalgorithms}{{\listof{algem}{\listalgorithmsname}}
    \addcontentsline{toc}{section}{\listalgorithmsname}}


% LISTA DE PUBLICACIONES
\newenvironment{citations}
{ 
  \chapter*{\citationname\@mkboth{\uppercase{\citationname}}%
   {\uppercase{\citationname}}}
   \addcontentsline{toc}{section}{\citationname}
   \ssp
}
{\dsp}




% REINICIA LA NUMERACIN ARBIGA
\newenvironment{startarabicpagination}
{   \cleardoublepage\dsp
    \setcounter{page}{1}
    \pagenumbering{arabic}
}
{}

%Prepara el encabezado para el glosario
\newcommand{\prepareglossary}{\cleardoublepage\@mkboth{\uppercase{Glosario}}%
   {\uppercase{Glosario}}}


% ---------------------------------------------
%                    LISTAS
% ---------------------------------------------


% ENUMERACIN
% La enumeracin se lleva a cabo por medio de los contadores enumi, enumii, 
% enumiii y enumiv, donde enumN controla la numeracin de el N-simo nivel
% de enumeracin. La etiqueta es generada por los comandos \labelenumi, 
% ... \labelenumiv. 

\def\labelenumi{\theenumi.}
\def\theenumi{\arabic{enumi}}

\def\labelenumii{(\theenumii)}
\def\theenumii{\alph{enumii}}
\def\p@enumii{\theenumi}

\def\labelenumiii{\theenumiii.}
\def\theenumiii{\roman{enumiii}}
\def\p@enumiii{\theenumi(\theenumii)}

\def\labelenumiv{\theenumiv.}
\def\theenumiv{\Alph{enumiv}}
\def\p@enumiv{\p@enumiii\theenumiii}

% VIETAS
% Se deinen las vietas para utilizar en diferentes niveles
% controlados por los comandos \labelitemi, \labelitemii, \labelitemiii,
% y \labelitemiv
\def\labelitemi{$\m@th\bullet$}
\def\labelitemii{\bfseries --}
\def\labelitemiii{$\m@th\ast$}
\def\labelitemiv{$\m@th\cdot$}


% VERSO
% Este ambiente se define para cuando se utilizan parmetros de listas,
% como el fin de line \\
\def\verse{\par\let\\=\@centercr
  \list{}{\ssp\itemsep\z@ \itemindent -1.5em\listparindent \itemindent
          \rightmargin\leftmargin\advance\leftmargin 1.5em}\item[]}
\let\endverse\endlist

% ENTRE COMILLAS
% Se utilizan renglones llenos con el prrafo sangra
\def\quotation{\par\list{}{\ssp\listparindent 1.5em
    \itemindent\listparindent
    \rightmargin\leftmargin\parsep \z@ plus\p@}\item[]}
\let\endquotation=\endlist

% QUOTE
% Se utilizan renglones llenos, pero no se sangra
\def\quote{\par\list{}{\ssp\rightmargin\leftmargin}\item[]}
\let\endquote=\endlist


% DESCRIPCIN
% Para cambiar el formato de la etiqueta, se debe redefinir 
% \descriptionlabel
\def\descriptionlabel#1{\hspace\labelsep \bfseries #1}
\def\description{\list{}{\labelwidth\z@ \itemindent-\leftmargin
       \let\makelabel\descriptionlabel}}

\let\enddescription\endlist

\newdimen\descriptionmargin
\descriptionmargin=3em


% ---------------------------------------------
%               OTROS AMBIENTES
% ---------------------------------------------


% VERBATIM
% para este ambiente se va a cambiar a espacio simple. Existen algunos
% problemas si se definen espacios mayores (con 1 o 2 pts, s funciona) despus
% de este ambiente. 

\def\@verbatim{\trivlist\ssp \scriptsize \item[]\if@minipage\else\vskip\parskip\fi
\leftskip\@totalleftmargin\rightskip\z@
\parindent\z@\parfillskip\@flushglue\parskip\z@
\@@par
\@tempswafalse \def\par{\if@tempswa\hbox{}\fi\@tempswatrue\@@par
\penalty\interlinepenalty}%
\obeylines \ttfamily \catcode``=13 \@noligs \let\do\@makeother \dospecials}

% ARRAY AND TABULAR
%
% ARREGLOS Y TABULARES
\arraycolsep 5pt     % La mitad del espacio entre columnas en arreglos.
\tabcolsep 6pt       % La mitade del espacio entre columnas en tabulares.
\arrayrulewidth .4pt % Ancho de reglas en arreglos y tabulares
\doublerulesep 2pt   % Espacios entre renglones adyacentes en arreglos y tabulares.

% Se redefine el arreglo para hacerlo espacio simple.
\def\array{\let\@acol\@arrayacol \let\@classz\@arrayclassz
 \let\@classiv\@arrayclassiv \let\\\@arraycr\let\@halignto\@empty\@tabarray}

% Espacio utilizado por el comando \'
\tabbingsep \labelsep   

% Se define el ambiente tabular para hacerlo espacio simple
\def\tabular{\par\ssp\let\@halignto\@empty\@tabular}
\expandafter \def\csname tabular*\endcsname #1%
{\par\ssp\def\@halignto{to#1}\@tabular}


% Se definen estilos tabulares alternativos \smalltabular y \smalltabular* 
% para cuando se utilizan fuentes \small. Se requieren porque en espaciado
% simple se requiere un cambio de fuente a un tamao particular
\def\smalltabular{\par\smallssp\let\@halignto\@empty\@tabular}
\def\endsmalltabular{\endtabular}
\expandafter \def\csname smalltabular*\endcsname #1%
{\par\smallssp\def\@halignto{to#1}\@tabular}
\expandafter \let \csname endsmalltabular*\endcsname = \endtabular

% \scriptsizetabular y \scriptsizetabular* son anlogos a \smalltabular
\def\scriptsizetabular{\par\scriptsizessp\let\@halignto\@empty\@tabular}
\def\endscriptsizetabular{\endtabular}
\expandafter \def\csname scriptsizetabular*\endcsname #1%
{\par\scriptsizessp\def\@halignto{to#1}\@tabular}
\expandafter \let \csname endscriptsizetabular*\endcsname = \endtabular

% MINIPAGE
% \@minipagerestore se llama en ambientes minipage para configurar las cosas
% que se manejan diferente dentro de una minipage. En los estilos actuales, no
% hace nada

%actua de la misma forma que en los pies de pgina normales
\skip\@mpfootins = \skip\footins


% FRAMEBOX
% Espacio entre una caja y el texto.
\fboxsep = 3pt    
% Ancho de las reglas en las cajas hechas por \fbox y \framebox
\fboxrule = .4pt  



% ---------------------------------------------
%               CAPTULOS Y SECCIONES
% ---------------------------------------------


% Se define @startsection para que siempre se sangre cuando comience una seccin
\def\@startsection#1#2#3#4#5#6{\if@noskipsec \leavevmode \fi
   \par \@tempskipa #4\relax
   \@afterindenttrue
   \ifdim \@tempskipa <\z@ \@tempskipa -\@tempskipa \relax\fi
   \if@nobreak \everypar{}\else
     \addpenalty{\@secpenalty}\addvspace{\@tempskipa}\fi \@ifstar
     {\@ssect{#3}{#4}{#5}{#6}}{\@dblarg{\@sect{#1}{#2}{#3}{#4}{#5}{#6}}}}

% Se definenen los contadores
\newcounter {part}
\newcounter {chapter}
\newcounter {section}[chapter]          %se reinicia cuando cambia el captulo
\newcounter {subsection}[section]       %se reinicia cuando cambia la seccin
\newcounter {subsubsection}[subsection] % ...
\newcounter {paragraph}[subsubsection]
\newcounter {subparagraph}[paragraph]


% Se definene las versiones imprimibles de los contadores, en arbigo, romano, alfanumrico, etc.
% 
\def\thepart          {\Roman{part}}
\def\thechapter       {\arabic{chapter}}
\def\thesection       {\thechapter.\arabic{section}}
\def\thesubsection    {\thesection.\arabic{subsection}}
\def\thesubsubsection {\thesubsection.\arabic{subsubsection}}
\def\theparagraph     {\thesubsubsection.\arabic{paragraph}}
\def\thesubparagraph  {\theparagraph.\arabic{subparagraph}}


% \@chapapp se define inicialmente para ser \chaptername. El comndo \appendix
% redefine su valor para ser \appendixname
\def\@chapapp{\chaptername}


% ---------------------------------------------
%               CONTENIDO
% ---------------------------------------------
% Un comando \subseciton escribe un comando \contentsline{subsection}{TITLE}{PAGE}
% en el archivo .toc, donde TITLE contiene el nombre de la seccin y PAGE es
% el nmero de pgina donde comienza la seccin. Si las subsecciones ban a ser
% numeradas, entonces TITLE ser de la forma \numberline{NUM}{HEADING}
% donde NUM es el nmero producido por \thesubsection. Otros comandos de seccin
% funcionan de forma similar
%
% Un comando \caption en una figura, por ejemplo, escribe 
%  \contentsline{figure}{\numerline{NUM}{CAPTION}}{PAGE}
% en el archivo .lof, donde NUM es el nmero producido por \thefigure y
% CAPTION es el nombre de la figura. Este trabaja de forma similar que table
%
% El comando \contentsline{NAME} se espande a \l@NAME. As, para especificar
% la tabla de contenido, se debe de definir \l@chapter, \l@section, 
% \l@figure, etctera. La mayora de estos pueden definirse con el comando
% \@dottedtocline, el cual trabaja de la siguiente manera
% 
% \@dottedtocline{LEVEL}{INDENT}{NUMWIDTH}{TITLE}{PAGE}
%   LEVEL   : Una entrada es producida slo si LEVEL <= al valor del contador 'tocdepth'.
%             Nota: \chapter es nivel 0, \section es nivel 1, etc.
%   INDENT  : El sangrado desde el margen ms a la izquierda del inicio de la linea de 
%             contenido
%   NUMWIDTH: El ancho de una caja en la cual ir el nmero de seccin, si TITLE incluye
%             el comando \numberline 
%
% Este comando utiliza los siguientes tres parmetros, que se especifican
% con \def
%  \@pnumwidth : El ancho de la caha en la que se coloca el nmero de pgina
%  \@tocrmarg  : El margen derecho para entradas de mltiple linea. 
%                se desea que \@tocrmarg > o = \@pnumwidth.
%  \@dotsep    : Separacin entre los puntos, en unidades mu. Deben definirse
%                \def a un nmero como 2 o 1.7
\def\@pnumwidth{1.55em}
\def\@tocrmarg {2.55em}
\def\@dotsep{4.5}
\setcounter{tocdepth}{2}


% TABLA DE CONTENIDO
% \tableofcontents, \listoffigures, etc. Van siempre en estilo de una columna
\def\tableofcontents{\@restonecolfalse
  \if@twocolumn\@restonecoltrue\onecolumn\fi
  \cleardoublepage\chapter*{\contentsname
        \@mkboth{\uppercase{\contentsname}}{\uppercase{\contentsname}}}%
  {\ssp\@starttoc{toc}}\if@restonecol\twocolumn\fi}


% CAPTULO
\def\l@chapter#1#2{\addpenalty{-\@highpenalty}%
   \vskip 1.0em plus\p@   % espacio sobre el nombre de captulo
   \@tempdima 1.5em       % ancho de la caja que contiene el nmero de captulo
   \begingroup
     \parindent \z@ \rightskip \@pnumwidth
     \parfillskip -\@pnumwidth
%    \bfseries                  % negrita
     \leavevmode          % comando TeX para cambiar a modo horizontal
      \advance\leftskip\@tempdima  
      \hskip -\leftskip            %para cambiar \numberline
     #1\nobreak\hfil \nobreak\hbox to\@pnumwidth{\hss #2}\par
     \penalty\@highpenalty 
   \endgroup}

\def\l@section{\@dottedtocline{1}{1.5em}{2.3em}}
\def\l@subsection{\@dottedtocline{2}{3.8em}{3.2em}}
\def\l@subsubsection{\@dottedtocline{3}{7.0em}{4.1em}}
\def\l@paragraph{\@dottedtocline{4}{10em}{5em}}
\def\l@subparagraph{\@dottedtocline{5}{12em}{6em}}


% LISTA  DE FIGURAS
% La lista de figuras en espacio simple, la agregan a una tabla de contenidos.
\def\listoffigures{\@restonecolfalse
  \if@twocolumn\@restonecoltrue\onecolumn\fi
  \chapter*{\listfigurename\@mkboth{\uppercase{\listfigurename}}%
{\uppercase{\listfigurename}}}
   \addcontentsline{toc}{section}{\listfigurename}
   {\ssp\@starttoc{lof}}\if@restonecol
    \twocolumn\fi}

\def\l@figure{\@dottedtocline{1}{1.5em}{2.3em}}

% LISTA DE TABLAS
\def\listoftables{\@restonecolfalse
  \if@twocolumn\@restonecoltrue\onecolumn\fi
  \chapter*{\listtablename\@mkboth{\uppercase{\listtablename}}%
   {\uppercase{\listtablename}}}\@starttoc{lot}\if@restonecol
  \twocolumn\fi}
\def\listoftables{\@restonecolfalse
  \if@twocolumn\@restonecoltrue\onecolumn\fi
  \chapter*{\listtablename\@mkboth{\uppercase{\listtablename}}%
{\uppercase{\listtablename}}}
   \addcontentsline{toc}{section}{\listtablename}
   {\ssp\@starttoc{lot}}\if@restonecol
  \twocolumn\fi}



\let\l@table\l@figure




% ---------------------------------------------
%               BIBLIOGRAFA
% ---------------------------------------------
% El ambiente de bibliografa ejecuta los siguientes comandos:
%   \def\newblock{\hskip .11em plus .33em minus .07em} --
%   define el formato 'cerrado', donde los bloques (unidades ms grandes
%   de informacin) de una entrada se despliegan juntos.
%
%   \sloppy -- Utilizado porque es difcil terminar lineas en bibliograas
%   
%   \sfcode`\.=1000\relax -- Cause un punto '.' sin producir un espacio de fin de 
%   oracin
%
% [ .. ] es remplazado por \@biblabel{ .. }
 

\def\thebibliography#1{\chapter*{\bibname\@mkboth
  {\uppercase{\bibname}}{\uppercase{\bibname}}}
  \addcontentsline{toc}{chapter}{\bibname}
  \list{\@biblabel{\arabic{enumiv}}}{\settowidth\labelwidth{\@biblabel{#1}}%
    \leftmargin\labelwidth
    \advance\leftmargin\labelsep
    \usecounter{enumiv}%
    \let\p@enumiv\@empty
    \def\theenumiv{\arabic{enumiv}}}%
    \def\newblock{\hskip .11em plus.33em minus.07em}%
    \sloppy\clubpenalty4000\widowpenalty4000
    \sfcode`\.=\@m}


% se crean warnings en lugar de errores
\def\endthebibliography{%
  \def\@noitemerr{\@warning{Empty `thebibliography' environment}}%
  \endlist}


% ---------------------------------------------
%               NDICE
% ---------------------------------------------
% AMBIENTE DE INDICE 
% Produce un formato de doble columna, con cada entrada en un prrafo diferente.
% os comandos de usuario \item, \subitem y \subsubitem se utilizan para producir
% las entradas, y \indexspace agrega un espacio vertical extra, que es el tamao
% correcto para una entrada con una nueva letra del alfabeto

\newif\if@restonecol

\def\theindex{\cleardoublepage\@restonecoltrue\if@twocolumn\@restonecolfalse\fi
\columnseprule \z@
\columnsep 35\p@\twocolumn[\@makeschapterhead{\indexname}]%
    \@mkboth{\uppercase{\indexname}}{\uppercase{\indexname}}%
    \thispagestyle{plain}\parindent\z@
    \parskip\z@ plus .3\p@\relax\let\item\@idxitem}

\def\@idxitem{\par\hangindent 40\p@}

\def\subitem{\par\hangindent 40\p@ \hspace*{20\p@}}

\def\subsubitem{\par\hangindent 40\p@ \hspace*{30\p@}}

\def\endtheindex{\if@restonecol\onecolumn\else\clearpage\fi}

\def\indexspace{\par \vskip 10\p@ plus5\p@ minus3\p@\relax}


% ---------------------------------------------
%               NOTAS AL PIE
% ---------------------------------------------
% \footnoterule es una macro para dibujar una lnea de separacin entre las
% notas al pie de pgina y el texto. No debera de tener espacio vertical, as que se 
% requiere un espacio negativo para compensar cualquier espacio positivo tomado
% por la lnea de separacin.
\def\footnoterule{\kern-3\p@
  \hrule width .4\columnwidth
  \kern 2.6\p@}                 % La \hrule tiene una altura por defecto de .4pt

% \newcounter{footnote}
\@addtoreset{footnote}{chapter}  % Nmero de pies de pgina dentro de cada captulo

%   \@makefntext{NOTE} -- Debe producir la nota al pie, usando \@thefnmark
%       de una nota al pie y NOTE como el texto. Este est llamado cuando dentro de un
%        \parbox de ancho \columnwidth (o.e., con \hsize = \columnwidth).
%
%       La siguiente macro crea una nota al pie cuyo texto es texto ordinario
%       de un prrafo, sin sangrado, excepto por la primer lnea de cada prrafo,
%       y la primer lnea de las notas al pie. As la macro todo lo que debe 
%       hacer es llamar a \parindent para el valor apropiado de prrafos sucesivos
%       y colocar el sangrado apropiado antes de una marca
%   \@makefnmark -- Es una macro para generar las marcas que van en el texto. Utilizado
%       por defecto
\long\def\@makefntext#1{\parindent 1em\noindent
            \hbox to 1.8em{\hss$\m@th^{\@thefnmark}$}#1}


% Notas al pie en documentos con espacio simple.
\long\def\@footnotetext#1{\insert\footins{\ssp\reset@font\footnotesize
    \interlinepenalty\interfootnotelinepenalty
    \splittopskip\footnotesep
    \splitmaxdepth \dp\strutbox \floatingpenalty \@MM
    \hsize\columnwidth \@parboxrestore
   \edef\@currentlabel{\csname p@footnote\endcsname\@thefnmark}\@makefntext
    {\rule{\z@}{\footnotesep}\ignorespaces
      #1\strut}}}
 
% ---------------------------------------------
%               FIGURAS Y TABLAS
% ---------------------------------------------
% Parmetros de objetos flotantes. 
\setcounter{topnumber}{2}
\def\topfraction{.7}
\setcounter{bottomnumber}{1}
\def\bottomfraction{.3}
\setcounter{totalnumber}{3}
\def\textfraction{.2}
\def\floatpagefraction{.5}
\setcounter{dbltopnumber}{2}
\def\dbltopfraction{.7}
\def\dblfloatpagefraction{.5}

% \@makecaption{NUMBER}{TEXT} -- Macro para configurar el ttulo de una figura o tabla
%       NUMBER -- Nmero de figura o tabla, e.g., 'Figura 3.2'
%       TEXT   -- El texto de la etiqueta.
% la macro debera ser llamada dentro de un \parbox de anchura correcta, con un 
% \normalsize.
%   El \unhbox permite que el material \vadjust (\vspace) salga; 
%   el \vbox para \topskip{} es para etiquetas sobre de los flotantes superiores;
%   el \ifdim es para etiquetas sobre las figuras o tablas.
%   el rsto es para tablas bajo las etiquetas.
\long\def\@makecaption#1#2{% Add space only if something is ...
   \par\ifdim\prevdepth>-\p@ \vskip 10\p@\relax \fi % above the caption
   \setbox\@tempboxa\hbox{\vbox to\topskip{}#1: #2\unskip\strut}%
   \ifdim \wd\@tempboxa >\hsize      % IF longer than one line:
       {\ssp#1: #2\unskip\strut\par} %   THEN set as ordinary paragraph.
     \else                           %   ELSE  center.
       \hbox to\hsize{\hfil\unhbox\@tempboxa\hfil}%
   \fi}

% Para definir un flotante tipo TYPE (e.g. Type=figure), el estilo de documento
% debe definir una de las siguientes.
%
% \fps@TYPE     -- El lugar especificado por defecto para flotantes de tipo TYPE.
%
% \ftype@TYPE   -- El tipo de nmero para flotantes de tipo TYPE. Cada TYPE tiene
%                  asociado  un nico, positivo, TYPE NUMBER, el cual es potencia
%                  de dos. E.g. Las figuras deberan de tener tipo de nmero 1, 
%                  tablas del tipo nmero 2, programas tipo nmero 4, etc.
%
% \ext@TYPE     -- La extensin indicada por el archivo en el que se almacena
%                  la lista de tipos flotantes TYPE. For ejemplo, \ext@figure = 'lof'.
% La creacin comandos de ambientes flotantes, e.g., los comandos
% \figure y \endfigure, se definen en trminos de macros \@float y \end@float
% que se describen a continuacin.
%
% \@float{TYPE}[PLACEMENT]  -- Macro para iniciar un ambiente flotante para
% un flotante, de tipo TYPE y locacin PLACEMENT, en columna simple. El valor
% por defecto de localizacin PLACEMENT es definido por \fps@TYPE. El ambiente
% temina por \end@float. E.g., \figure==\@float{figure}, \endfigure == \end@float.

% FIGURAS
\newcounter{figure}[chapter]
\def\thefigure{\thechapter.\@arabic\c@figure}

\def\fps@figure{tbp}
\def\ftype@figure{1}
\def\ext@figure{lof}
\def\fnum@figure{\figurename~\thefigure}
\def\figure{\@float{figure}}

\def\endfigure{\end@float}
\@namedef{figure*}{\@dblfloat{figure}}
\@namedef{endfigure*}{\end@dblfloat}

% TABLAS
\newcounter{table}[chapter]
\def\thetable{\thechapter.\@arabic\c@table}

\def\fps@table{tbp}
\def\ftype@table{2}
\def\ext@table{lot}
\def\fnum@table{\tablename~\thetable}
\def\table{\@float{table}}

\def\endtable{\end@float}
\@namedef{table*}{\@dblfloat{table}}
\@namedef{endtable*}{\end@dblfloat}


% ---------------------------------------------
%               ESTILOS DE PGINA
% ---------------------------------------------
% El estilo de pgina 'foo' se define por el comendo \ps@foo. Este comando
% debera hacer slo definiciones locales. No debera haber espacios en la 
% definicin, puesto que podran causar misteriosos espacios extra en la 
% salida.
%
% El comando \ps@...  define las macros \@oddhead, \@oddfoot, \@evenhead, y
% \@evenfoot para definir las cabeceras y pies de pgina.Por ejemplo, \@oddhead
% es la macro para producir el contenido de una caja de cabecera para pginas
% impares. Se llama dentro de un \hbox de ancho \textwidth.
% 
% Para hacer cabeceras determinadas por comandos de seccin, los estilos de pgina
% definen los comandos \chaptermark, \sectionmark, ..., donde, \chaptermark{TEXT}
% es llamado por \chapter para poner una marca, y as sucesivamente.
% Los comandos \...mark y los comandos \...head se definen con ayuda de las
% siguientes macros. (Todos los comandos \...mark deberan ser inicializados)
% para no realizar operaciones.
%
% CONVENCIONES:
% LaTeX extiende la macro \mark de TeX para facilitar la realizacin de
% marcas a la izquierda y derecha utilizando los siguientes comandos:
%   \markboth{LEFT}{RIGHT}  -- Agrega ambas marcas.
%   \markright{RIGHT}       -- Agrega una marca a la derecha.
%   \leftmark   -- Utilizada en \@oddhead, \@oddfoot, \@evenhead o \@evenfoot.
%                  obtiene la marca de la izquierda actual.
%   \rightmark  -- Utilizada en \@oddhead, \@oddfoot, \@evenhead o \@evenfoot,
%                  obtiene la marca de la derecha actual.
% Los comandos marking trabajan razonablemente bien para marcas a la derecha
% numeradas dentro de marcas a la izquierda. e.g. la marca de la izquierda
% se cambia por el comando \chaptar y la marca de la derecha se cambia por 
% el comando \section. Sin embargo, esto s produce algunos resultados anmalos
% si dos \bothmark ocurren en la misma pgina
%
% Comandos como \tableofcontents que deben colocar algunas marcas en algn
% estilo de pginas utilizan el comando \@mkboth , que es \let por el estilo
% de pgina (\@ps@...) en \markboth para colocar la cabecera  o para que 
% \@gobbletwo no haga nada.

\mark{{}{}}   % Inicializa las marcas TeX

% \ps@empty est definido en LATEX.TEX

% Definicin del estilo de pgina 'headings'
% Note el uso del parmetro ##1 en \def\chaptermark dentro de 
% \def\ps@headings.
\def\ps@headings{\let\@mkboth\markboth
 \def\@oddfoot{}\def\@evenfoot{}%       No feet.
 \def\@evenhead{\rmfamily \thepage\hfil \slshape \leftmark}%    Left heading.
 \def\@oddhead{{\slshape \rightmark}\hfil \rmfamily\thepage}% Right heading.

 \def\chaptermark##1{\markboth {\ifnum \c@secnumdepth >\m@ne\@chapapp\ \MakeUppercase{\thechapter}. \ \fi ##1}{}}%      
 \def\sectionmark##1{\markright {\ifnum \c@secnumdepth >\z@ \thesection. \ \fi ##1}}}


% Definicin del estilo de pgina 'myheadings'
%
\def\ps@myheadings{\let\@mkboth\@gobbletwo
 \def\@oddhead{{\slshape\rightmark}\hfil \rmfamily\thepage}%
 \def\@oddfoot{}\def\@evenhead{\rmfamily \thepage\hfil\slshape\leftmark}%
 \def\@evenfoot{}\def\chaptermark##1{}\def\sectionmark##1{}%
 \def\subsectionmark##1{}}

% Definicin del estilo de pgina 'plain'
%
\def\ps@plain{\let\@mkboth\markboth
\def\@oddfoot{}\def\@evenfoot{}                         % no feet
\def\@oddhead{\hbox{}\hfil\rmfamily\thepage}            % heading (right)
\def\@evenhead{\rmfamily\thepage\hfil\hbox{}}}          % heading (left)


% ---------------------------------------------
%               PERSONALIZACIN
% ---------------------------------------------

%DA
%Pone en formato Mes Da Ao
\def\today{\ifcase\month\or
  Enero\or Febrero\or Marzo\or Abril\or Mayo\or Junio\or
  Julio\or Agosto\or Septiembre\or Octubre\or Noviembre\or Diciembre\fi
  \space\number\day, \number\year}

% EQUATION and EQNARRAY -- put here because it must follow \chapter
% definition
%
% \newcounter{equation}
%
\@addtoreset{equation}{chapter}   % Makes \chapter reset 'equation'
                                  % counter.
% EQUATION Y EQNARRAY
\def\theequation{\thechapter.\arabic{equation}} %hace que el comando \chapter 
                                                %cambie el contador de ecuacin

% ---------------------------------------------
%               INICIALIZACIN
% ---------------------------------------------



% Inicializacin de 
\ps@plain                   % estilo de pgina 'plain'
\pagenumbering{arabic}      % Nmeros de pgina arbigos


% cabeceras y pies de pgina
\pagestyle{fancy}

% \@chapapp sabe cuando se est en un apndice
\renewcommand{\chaptermark}[1]{\markboth{\@chapapp\ \thechapter:\ #1}{}}

\fancyhf{}

%Definimos las cabeceras de las pginas para las pginas pares e impares
% La pgina impar contiene el nombre de la seccin 
% La pgina par contiene el nombre del captulo
\fancyhead{}
\fancyhead[LE, RO]{\iffloatpage{\rmfamily\thepage}{\rmfamily\thepage}}
\fancyhead[LO]{\iffloatpage{\nouppercase{\slshape\rightmark}}{\nouppercase{\slshape\rightmark}}}
\fancyhead[RE]{\iffloatpage{\hfil\nouppercase{\slshape\leftmark}}{\hfil\nouppercase{\slshape\leftmark}}}
\renewcommand{\headrulewidth}{0.4pt}
\renewcommand{\footrulewidth}{0pt}

% Redefinimos el estilo 'plain' para cuando no va a llevar cabecera, como en 
% el inicio de un captulo
\fancypagestyle{plain}{
  \fancyhf{}
  \fancyfoot[C]{\thepage}
  \renewcommand{\headrulewidth}{0pt}
  \renewcommand{\footrulewidth}{0pt}
}


\newcommand{\shortchap}{}
\newcommand{\hackchapter}[2]{
  \renewcommand{\shortchap}{\itshape \large \@chapapp \thechapter:  #2}
  \chapter{#1}
}



% 11 pt
\if@elpt
%\addtolength{\textheight}{0.2in} % this seems a hack
\setlength{\headwidth}{\textwidth}
\addtolength{\headheight}{2pt}
\fi

% 12 pt
\if@twpt
%\addtolength{\textheight}{-.2in} 
\setlength{\headwidth}{\textwidth}
\fi

% mrgenes en los que se contempla el doble paginado
\setlength{\topmargin}{0in} % desplaza 0in desde arriba.
\setlength{\oddsidemargin}{.7in} % desplaza 1.5in desde lado izquierdo.
\setlength{\evensidemargin}{-.2in} % desplaza -0.1in desde el lado izquierdo.
\textwidth 6in % desplaza 6in desde la derecha
% El alto del texto (texthight) es del mismo tamao que el cuerpo, y es un poco menor
% a 9in: no modificar.

%Estilo de bibliografa a utilizar
\bibliographystyle{tfiebib}

\coadvisorone{}%
\coadvisortwo{}%
\coadvisorthree{}%



\endinput
